package xyz.lychee.lagfixer.menu;

import java.util.Collections;
import java.util.Iterator;
import org.bukkit.Bukkit;
import org.bukkit.Chunk;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.entity.HumanEntity;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.ItemStack;
import xyz.lychee.lagfixer.LagFixer;
import xyz.lychee.lagfixer.managers.CommandManager;
import xyz.lychee.lagfixer.managers.ModuleManager;
import xyz.lychee.lagfixer.managers.SupportManager;
import xyz.lychee.lagfixer.objects.AbstractMenu;
import xyz.lychee.lagfixer.objects.AbstractModule;
import xyz.lychee.lagfixer.objects.AbstractMonitor;
import xyz.lychee.lagfixer.objects.AbstractSupportNms;
import xyz.lychee.lagfixer.utils.ItemBuilder;
import xyz.lychee.lagfixer.utils.MessageUtils;

public class MainMenu extends AbstractMenu {
   private final ItemBuilder i1 = ItemBuilder.createSkull("eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvZWMyZmYyNDRkZmM5ZGQzYTJjZWY2MzExMmU3NTAyZGM2MzY3YjBkMDIxMzI5NTAzNDdiMmI0NzlhNzIzNjZkZCJ9fX0=").setName("&f&lConfiguration!").setLore(new String[]{" &8{*} &7Loading lore..."});
   private final ItemBuilder i2 = ItemBuilder.createSkull("eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYWNjNzg5ZjIzMDc5NGY5MGUzM2M0ZjlhZDAwNjk0YmMyYTJmZjVlOGI5YjM3NWRjMzUzMjQwMWIyODFmM2U1OCJ9fX0=").setName("&f&lServer informations:").setLore(new String[]{" &8{*} &7Loading lore..."});
   private final ItemBuilder i3 = ItemBuilder.createSkull("eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvMTI4OWQ1YjE3ODYyNmVhMjNkMGIwYzNkMmRmNWMwODVlODM3NTA1NmJmNjg1YjVlZDViYjQ3N2ZlODQ3MmQ5NCJ9fX0=").setName("&f&lWorlds informations:").setLore(new String[]{" &8{*} &7Loading lore..."});
   private final ItemBuilder i4 = ItemBuilder.createSkull("eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvYmQ5ZjE4YzlkODVmOTJmNzJmODY0ZDY3YzEzNjdlOWE0NWRjMTBmMzcxNTQ5YzQ2YTRkNGRkOWU0ZjEzZmY0In19fQ==").setName("&f&lServer fork optimizer:").setLore(new String[]{" &8{*} &7Loading lore..."});

   public MainMenu(LagFixer plugin, int size, String title) {
      super(plugin, size, title, true, true);
      this.surroundInventory();
   }

   public void update() {
      SupportManager support = SupportManager.getInstance();
      this.i1.setLore(new String[]{" &8{*} &7Loaded modules: &e" + ModuleManager.getInstance().getModules().values().stream().filter(AbstractModule::isLoaded).count() + "&8/&e" + ModuleManager.getInstance().getModules().size(), " &8{*} &7Version: &e" + this.getPlugin().getDescription().getVersion(), "", "&eClick to modify configuration!"});
      AbstractMonitor monitor = support.getMonitor();
      this.i2.setLore(new String[]{" &8{*} &7Tps: &e" + monitor.getTps(), " &8{*} &7Mspt: &e" + monitor.getMspt(), " &8{*} &7Memory: &e" + monitor.getRamUsed() + "&8/&e" + monitor.getRamTotal() + "&8/&e" + monitor.getRamMax() + " MB", " &8{*} &7Cpu process: &e" + monitor.getCpuProcess() + "&f%", " &8{*} &7Cpu system: &e" + monitor.getCpuSystem() + "&f%", "", "&eClick to open components menu!"});
      AbstractSupportNms nms = support.getNms();
      int chunks = 0;
      int tiles = 0;
      Iterator var6 = Bukkit.getWorlds().iterator();

      while(var6.hasNext()) {
         World w = (World)var6.next();
         Chunk[] arrchunks = w.getLoadedChunks();
         chunks += arrchunks.length;
         Chunk[] var9 = arrchunks;
         int var10 = arrchunks.length;

         for(int var11 = 0; var11 < var10; ++var11) {
            Chunk chunk = var9[var11];
            tiles += nms.getTileEntitiesCount(chunk);
         }
      }

      this.i3.setLore(new String[]{" &8{*} &7Chunks: &e" + chunks, " &8{*} &7Creatures: &e" + support.getCreatureCount(), " &8{*} &7Items: &e" + support.getItemCount(), " &8{*} &7Projectiles: &e" + support.getProjectileCount(), " &8{*} &7Tile entities: &e" + tiles, " &8{*} &7Players: &e" + Bukkit.getOnlinePlayers().size() + "&8/&e" + Bukkit.getMaxPlayers(), "", "&eClick to open cleaner menu!"});
      this.i4.setLore(Collections.singletonList("&eClick to open configurator menu!"));
      this.getInv().setItem(10, this.i1.build());
      this.getInv().setItem(12, this.i2.build());
      this.getInv().setItem(14, this.i3.build());
      this.getInv().setItem(16, this.i4.build());
      this.fillInventory();
   }

   public void handleClick(InventoryClickEvent e, ItemStack item) {
      if (item.getType() == Material.PLAYER_HEAD) {
         HumanEntity human = e.getWhoClicked();
         if (e.getSlot() == 10) {
            ModulesMenu menu = CommandManager.getInstance().getModulesMenu();
            menu.update();
            human.openInventory(menu.getInv());
         } else {
            MessageUtils.sendMessage(true, human, "Click event will be added soon.");
         }
      }

   }

   public AbstractMenu previousMenu() {
      return null;
   }
}
